
/////////////////////////////////////////////////////////////
//
// Source file for BulletinBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from BulletinBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this source, limit your changes to 
//    modifying the sections between the
//    "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
/////////////////////////////////////////////////////////////

#include "BulletinBoard.h"
#include <Vk/VkEZ.h>
#include <GL/GLwMDrawA.h> 
#include <Sgm/Dial.h> 
#include <Xm/BulletinB.h> 
#include <Xm/Frame.h> 
#include <Xm/Label.h> 
#include <Xm/PushB.h> 
#include <Xm/Scale.h> 
#include <Xm/Separator.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
#include <Vk/VkOptionMenu.h>
#include <Vk/VkMenuItem.h>
#include <Vk/VkWindow.h>
#include <Vk/VkMenuBar.h>
#include <Vk/VkSubMenu.h>


extern void VkUnimplemented ( Widget, const char * );

///////////////////////////////////////////////////////////////////////////////
// The following non-container elements are created by BulletinBoardUI and are
// available as protected data members inherited by this class
//
//  XmPushButton		    _writeAnimation
//  XmPushButton		    _writeOneFile
//  XmScale		    _extraSlider
//  XmScale		    _epsilon
//  XmLabel		    _setFinalAngle
//  XmLabel		    _setInitialAngle
//  XmSeparator		    _separator3
//  XmSeparator		    _separator2
//  XmPushButton		    _addToObstacle
//  XmPushButton		    _computePath
//  SgDial		    _finalAngle
//  SgDial		    _initialAngle
//  XmPushButton		    _setInitialPos
//  XmPushButton		    _setFinalPos
//  XmPushButton		    _setAsRobot
//  XmPushButton		    _clearRobot
//  XmPushButton		    _clearObstacles
//  VkOptionMenu *		    _planningMethod
//  VkMenuItem *		    _randomRoadmap
//  VkMenuItem *		    _randomTree
//  XmPushButton		    _animatePath
//  XmToggleButton (LED style)		    _showPathLine
//  XmToggleButton (LED style)		    _showAllSegments
//  VkOptionMenu *		    _yAxisIdentification
//  VkMenuItem *		    _yNone
//  VkMenuItem *		    _yOn
//  VkMenuItem *		    _yReverse
//  VkOptionMenu *		    _xAxisIdentification
//  VkMenuItem *		    _xnone
//  VkMenuItem *		    _xOn
//  VkMenuItem *		    _xReverse
//  GLwMDrawingArea		    _display
//
///////////////////////////////////////////////////////////////////////////////


//---- Start editable code block: headers and declarations

#include <iostream.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>
#include <stdio.h>
#include "XwindowSupport.h"
#include <math.h>
#include "planner.h"

float bgColor[4];

float glpos[2];
float pickpos[2];
planner plan;
static int justpressed;

int drawsegments = 0;
int drawpathline = 0;

//---- End editable code block: headers and declarations


//---- BulletinBoard Constructor

BulletinBoard::BulletinBoard(const char *name, Widget parent) : 
                   BulletinBoardUI(name, parent) 
{ 
    // This constructor calls BulletinBoardUI(parent, name)
    // which calls BulletinBoardUI::create() to create
    // the widgets for this component. Any code added here
    // is called after the component's interface has been built

    //---- Start editable code block: BulletinBoard constructor


    //---- End editable code block: BulletinBoard constructor



}    // End Constructor



BulletinBoard::BulletinBoard(const char *name) : 
                   BulletinBoardUI(name) 
 { 
    // This constructor calls BulletinBoardUI(name)
    // which does not create any widgets. Usually, this
    // constructor is not used

    //---- Start editable code block: BulletinBoard constructor 2


    //---- End editable code block: BulletinBoard constructor 2



}    // End Constructor



BulletinBoard::~BulletinBoard()
{
    // The base class destructors are responsible for
    // destroying all widgets and objects used in this component.
    // Only additional items created directly in this class
    // need to be freed here.

    //---- Start editable code block: BulletinBoard destructor


    //---- End editable code block: BulletinBoard destructor



}    // End Destructor


const char * BulletinBoard::className() // classname
{
    return ("BulletinBoard");
} // End className()


void BulletinBoard::doAddToObstacle ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doAddToObstacle

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doAddToObstacle is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doAddToObstacle" );

    plan.addNewPolyToObs();
    draw(w, callData);

    //---- End editable code block: BulletinBoard doAddToObstacle

}    // End BulletinBoard::doAddToObstacle()


void BulletinBoard::doAnimatePath ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doAnimatePath

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doAnimatePath is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doAnimatePath" );

    
    d3_point animpt;
    forall(animpt, plan.path){
      plan.currentpt = animpt;
      draw(w, callData);
    }

    //---- End editable code block: BulletinBoard doAnimatePath

}    // End BulletinBoard::doAnimatePath()


void BulletinBoard::doClearObstacles ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doClearObstacles

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doClearObstacles is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doClearObstacles" );

    plan.clearObs();
    draw(w, callData);

    //---- End editable code block: BulletinBoard doClearObstacles

}    // End BulletinBoard::doClearObstacles()


void BulletinBoard::doClearRobot ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doClearRobot

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doClearRobot is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doClearRobot" );

    plan.clearRob();
    draw(w, callData);

    //---- End editable code block: BulletinBoard doClearRobot

}    // End BulletinBoard::doClearRobot()


void BulletinBoard::doComputePath ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doComputePath

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doComputePath is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doComputePath" );

    plan.computepath();
    draw(w, callData);


    //---- End editable code block: BulletinBoard doComputePath

}    // End BulletinBoard::doComputePath()


void BulletinBoard::doSetAsRobot ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doSetAsRobot

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doSetAsRobot is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doSetAsRobot" );

    plan.newPolyIsRobot();
    draw(w, callData);

    //---- End editable code block: BulletinBoard doSetAsRobot

}    // End BulletinBoard::doSetAsRobot()


void BulletinBoard::doSetFinalPos ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doSetFinalPos

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doSetFinalPos is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doSetFinalPos" );

    plan.finalPt(pickpos[0], pickpos[1]);
    draw(w, callData);

    //---- End editable code block: BulletinBoard doSetFinalPos

}    // End BulletinBoard::doSetFinalPos()


void BulletinBoard::doSetInitialPos ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doSetInitialPos

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doSetInitialPos is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doSetInitialPos" );

    plan.initPt(pickpos[0], pickpos[1]);

    draw(w, callData);

    //---- End editable code block: BulletinBoard doSetInitialPos

}    // End BulletinBoard::doSetInitialPos()


void BulletinBoard::doWriteAnimation ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doWriteAnimation

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doWriteAnimation is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doWriteAnimation" );
    
    d3_point animpt;
    int i= 10;    
    forall(animpt, plan.path){
      i++;
      plan.currentpt = animpt;
      //      sprintf(plan.filename, "output/anim%d.ps", i); 
      plan.writefile();
      draw(w,callData);
    }
    plan.anim++;
    plan.id = 0;
    draw(w,callData);
    
    //---- End editable code block: BulletinBoard doWriteAnimation

}    // End BulletinBoard::doWriteAnimation()


void BulletinBoard::doWriteOneFile ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doWriteOneFile

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doWriteOneFile is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doWriteOneFile" );

    //    sprintf(plan.filename, "output/output_one.ps"); 
    plan.writefile();
    draw(w, callData);



    //---- End editable code block: BulletinBoard doWriteOneFile

}    // End BulletinBoard::doWriteOneFile()


void BulletinBoard::doXNone ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doXNone

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doXNone is implemented:

    //    ::VkUnimplemented ( w, "BulletinBoard::doXNone" );

    plan.xident = 0;
    draw(w, callData);

    //---- End editable code block: BulletinBoard doXNone

}    // End BulletinBoard::doXNone()


void BulletinBoard::doXOn ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doXOn

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doXOn is implemented:

    //    ::VkUnimplemented ( w, "BulletinBoard::doXOn" );

    plan.xident = 1;
    draw(w, callData);


    //---- End editable code block: BulletinBoard doXOn

}    // End BulletinBoard::doXOn()


void BulletinBoard::doXReverse ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doXReverse

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doXReverse is implemented:

    //    ::VkUnimplemented ( w, "BulletinBoard::doXReverse" );

    plan.xident = 2;
    draw(w, callData);


    //---- End editable code block: BulletinBoard doXReverse

}    // End BulletinBoard::doXReverse()


void BulletinBoard::doYNone ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doYNone

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doYNone is implemented:

    //    ::VkUnimplemented ( w, "BulletinBoard::doYNone" );

    plan.yident = 0;
    draw(w, callData);


    //---- End editable code block: BulletinBoard doYNone

}    // End BulletinBoard::doYNone()


void BulletinBoard::doYOn ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doYOn

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doYOn is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::doYOn" );

    plan.yident = 1;
    draw(w, callData);

    //---- End editable code block: BulletinBoard doYOn

}    // End BulletinBoard::doYOn()


void BulletinBoard::doYReverse ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard doYReverse

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::doYReverse is implemented:
    //    ::VkUnimplemented ( w, "BulletinBoard::doYReverse" );
    plan.yident = 2;
    draw(w, callData);
    //---- End editable code block: BulletinBoard doYReverse

}    // End BulletinBoard::doXReverse()



void BulletinBoard::draw ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard draw

    GLwDrawingAreaCallbackStruct *cbs = (GLwDrawingAreaCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::draw is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::draw" );
    
    makeGLCurrent();
    glViewport(0,0,XWINDOWSIZE, YWINDOWSIZE);
    
    glClearColor(bgColor[0], bgColor[1], bgColor[2], bgColor[3]);
    glEnable(GL_DEPTH_TEST);            
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT  );
    
    glEnable(GL_NORMALIZE);
    glEnable(GL_COLOR);
    
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluOrtho2D(0.0, XWINDOWSIZE, 0.0, YWINDOWSIZE);
    glMatrixMode(GL_MODELVIEW);


    // drawTheRobot
    // drawTheObstacles

    // drawFinalPosition
    glPushMatrix();
    glTranslatef(plan.finalpt.xcoord(), plan.finalpt.ycoord(), 0.0);
    glRotatef( plan.finalpt.zcoord() * 360.0/TWOPI, 0.0,0.0,1.0);
    glColor3f(1.0, 0.0, 0.0); // red
    glBegin(GL_POLYGON);
    glVertex2f(0,8);
    glVertex2f(-3,0);
    glVertex2f(3,0);
    glEnd();
    glPopMatrix();

    // draw Initial Pos
    glPushMatrix();
    glTranslatef(plan.initpt.xcoord(), plan.initpt.ycoord(), 0.0);
    glRotatef( plan.initpt.zcoord() * 360.0/TWOPI, 0.0,0.0,1.0);
    glColor3f(0.0, 0.0, 1.0); // blue
    glBegin(GL_POLYGON);
    glVertex2f(0,8);
    glVertex2f(-3,0); 
    glVertex2f(3,0);
    glEnd();
    glPopMatrix();
    

    // draw pick pos
    glColor3f(.5, .5, .9);
    glBegin(GL_LINES);
    glVertex2f(pickpos[0]+4.0, pickpos[1]+4.0);
    glVertex2f(pickpos[0]-4.0, pickpos[1]-4.0);
    glVertex2f(pickpos[0]+4.0, pickpos[1]-4.0);
    glVertex2f(pickpos[0]-4.0, pickpos[1]+4.0);
    glEnd();

    point drawpt;
    d3_point draw3pt;
    edge drawedge;

    // drawNewPoly if size >0
    if (plan.newpoly.size() > 2){
      glColor3f(.5, .8, .1);
      glBegin(GL_POLYGON);
      forall_vertices(drawpt,plan.newpoly){
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
      glEnd();
    } else if (plan.pl.size() < 3){
      glColor3f(.5, .8, .1);
      glBegin(GL_LINE_LOOP);
      forall(drawpt,plan.pl){
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
      glEnd();
    }
      
    // drawRobot
    polygon drawbot = plan.robot;
    drawbot = drawbot.rotate(point(0,0), plan.currentpt.zcoord());
    drawbot = drawbot.translate(plan.currentpt.xcoord(),  
				plan.currentpt.ycoord());
    
    if (plan.robot.size() > 2){

      if (plan.isValid(plan.currentpt)){
	glColor3f(.7, .3, .2);
      } else {
	glColor3f(.2, .1, .2);
      }
      glBegin(GL_POLYGON);
      forall_vertices(drawpt,drawbot){
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
    }
    glEnd();


    // drawFinalRobot pos
    drawbot = plan.robot;
    drawbot = drawbot.rotate(point(0,0), plan.finalpt.zcoord());
    drawbot = drawbot.translate(plan.finalpt.xcoord(),  
				plan.finalpt.ycoord());
    if (plan.robot.size() > 2){
      if (plan.isValid(plan.finalpt)){	glColor3f(.7, .3, .2);
      } else {	glColor3f(.2, .1, .2);
      }
      glBegin(GL_LINE_LOOP);
      forall_vertices(drawpt,drawbot){
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
    }
    glEnd();

    // drawInitRobot pos
    drawbot = plan.robot;
    drawbot = drawbot.rotate(point(0,0), plan.initpt.zcoord());
    drawbot = drawbot.translate(plan.initpt.xcoord(),  
				plan.initpt.ycoord());
    if (plan.robot.size() > 2){
      if (plan.isValid(plan.initpt)){	glColor3f(.7, .3, .2);
      } else {	glColor3f(.2, .1, .2);
      }
      glBegin(GL_LINE_LOOP);
      forall_vertices(drawpt,drawbot){
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
    }
    glEnd();

    // drawObsticles

    polygon drawpoly;
    glColor3f(0, .2, .1);
    forall(drawpoly, plan.O){ // draw all polygons in O
      glBegin(GL_POLYGON);
      forall_vertices(drawpt, drawpoly){ // draw all vertices in drawpoly
	glVertex2f(drawpt.xcoord(), drawpt.ycoord());
      }
      glEnd();
    }
    
    node s, t;
    
    // draw all path lines
    if (drawsegments== 1){
      
      // draw indicator arrows at all nodes
      glBegin(GL_POINTS);
      forall_nodes(s,plan.G){
	draw3pt = plan.G.inf(s);
	glPushMatrix();
	glTranslatef(draw3pt.xcoord(), draw3pt.ycoord(), 0.0);
	glRotatef( draw3pt.zcoord() * 360.0/TWOPI, 0.0,0.0,1.0);
	glColor3f(0.0, 1.0, 0.0); // green
	glBegin(GL_POLYGON);
	glVertex2f(0,8);
	glVertex2f(-2,0); 
	glVertex2f(2,0);
	glEnd();
	glPopMatrix();
	
      }
      glEnd();
      
      // draw edges
      glLineWidth(1);
      glPointSize(2);
      
      glColor3f(0.5, 0.5, 0.5);
      glBegin(GL_LINES);
      forall_edges(drawedge, plan.G){
	s = plan.G.source(drawedge);
	draw3pt = plan.G.inf(s);
	glVertex2f(draw3pt.xcoord(), draw3pt.ycoord());
	
	t = plan.G.target(drawedge);
	draw3pt = plan.G.inf(t);
	glVertex2f(draw3pt.xcoord(), draw3pt.ycoord());
      }
      glEnd();
    }
    
    // draw pathline
    if (drawpathline == 1){
      glBegin(GL_LINE_STRIP);
      glColor3f(0, 1.0, 1.0);
      forall(draw3pt, plan.path){
	glVertex2f(draw3pt.xcoord(), draw3pt.ycoord());
      }
      glEnd();

      // draw indicator arrows at all nodes
      glBegin(GL_POINTS);
      forall(draw3pt,plan.path){
	glPushMatrix();
	glTranslatef(draw3pt.xcoord(), draw3pt.ycoord(), 0.0);
	glRotatef( draw3pt.zcoord() * 360.0/TWOPI, 0.0,0.0,1.0);
	glColor3f(0.2, 0.2, 1.0); // green
	glBegin(GL_POLYGON);
	glVertex2f(0,8);
	glVertex2f(-2,0); 
	glVertex2f(2,0);
	glEnd();
	glPopMatrix();
	
      }
      glEnd();


      // draw path line;
    }

    GLSwapBuffers();

    //---- End editable code block: BulletinBoard draw

}    // End BulletinBoard::draw()


void BulletinBoard::init ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard init

    GLwDrawingAreaCallbackStruct *cbs = (GLwDrawingAreaCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::init is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::init" );

    bgColor[0] = .9;
    bgColor[1] = .9;
    bgColor[2] = .9;
    bgColor[3] = 0.0;

    initGLWindow(w, callData);

    //---- End editable code block: BulletinBoard init

}    // End BulletinBoard::init()


void BulletinBoard::interact ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard interact

    GLwDrawingAreaCallbackStruct *cbs = (GLwDrawingAreaCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::interact is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::interact" );

    int xx,  yy;
    getMouseLocation(&xx,  &yy);
    glpos[0] = xx;
    glpos[1] = YWINDOWSIZE - yy;
    
    if ((glpos[0] > 0) && 
	(glpos[1] < XWINDOWSIZE) &&
	(glpos[0] > 0) && 
	(glpos[1] < XWINDOWSIZE)){
      pickpos[0] = glpos[0];
      pickpos[1] = glpos[1];
    }
    
    if (getMouseButton(MIDDLEBUTTON)){
      plan.addToNewPoly(pickpos[0], pickpos[1]);
    } 

    if (getMouseButton(RIGHTBUTTON)){
      plan.initPt(pickpos[0], pickpos[1]);
    } 

    if (getMouseButton(LEFTBUTTON)){
      plan.finalPt(pickpos[0], pickpos[1]);
    } 

    draw(w, callData);

    //---- End editable code block: BulletinBoard interact

}    // End BulletinBoard::interact()


void BulletinBoard::onFinalAngle ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onFinalAngle

    SgDialCallbackStruct *cbs = (SgDialCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onFinalAngle is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onFinalAngle" );

    plan.finalAngle(360-EZ(w));
    draw(w, callData);

    //---- End editable code block: BulletinBoard onFinalAngle

}    // End BulletinBoard::onFinalAngle()


void BulletinBoard::onInitialAngle ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onInitialAngle

    SgDialCallbackStruct *cbs = (SgDialCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onInitialAngle is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onInitialAngle" );

    plan.initAngle(360-EZ(w));
    draw(w, callData);

    //---- End editable code block: BulletinBoard onInitialAngle

}    // End BulletinBoard::onInitialAngle()


void BulletinBoard::onRandomRoadMapSelect ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onRandomRoadMapSelect

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onRandomRoadMapSelect is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onRandomRoadMapSelect" );

    plan.method = ROADMAP;
    draw(w, callData);

    //---- End editable code block: BulletinBoard onRandomRoadMapSelect

}    // End BulletinBoard::onRandomRoadMapSelect()


void BulletinBoard::onRandomTreeSelect ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onRandomTreeSelect

    XmPushButtonCallbackStruct *cbs = (XmPushButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onRandomTreeSelect is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onRandomTreeSelect" );

    plan.method = RANDTREE;
    draw(w, callData);


    //---- End editable code block: BulletinBoard onRandomTreeSelect

}    // End BulletinBoard::onRandomTreeSelect()


void BulletinBoard::onSetEpslion ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onSetEpslion

    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onSetEpslion is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onSetEpslion" );

    plan.epsilon = EZ(w) * 3;
    //    cout  << "eps = " << plan.epsilon << endl;
    draw(w, callData);

    //---- End editable code block: BulletinBoard onSetEpslion

}    // End BulletinBoard::onSetEpslion()


void BulletinBoard::onSetExtraSlider ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard onSetExtraSlider

    XmScaleCallbackStruct *cbs = (XmScaleCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::onSetExtraSlider is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::onSetExtraSlider" );

    plan.angledistfactor = float(EZ(w));
    //    cout << "Angle change weight is " <<plan.angledistfactor << endl;
    draw(w, callData);

    //---- End editable code block: BulletinBoard onSetExtraSlider

}    // End BulletinBoard::onSetExtraSlider()


void BulletinBoard::setShowAllSegments ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard setShowAllSegments

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::setShowAllSegments is implemented:

    //::VkUnimplemented ( w, "BulletinBoard::setShowAllSegments" );

    drawsegments = EZ(w);
    draw(w, callData);

    //---- End editable code block: BulletinBoard setShowAllSegments

}    // End BulletinBoard::setShowAllSegments()


void BulletinBoard::setShowPathLine ( Widget w, XtPointer callData )
{
    //---- Start editable code block: BulletinBoard setShowPathLine

    XmToggleButtonCallbackStruct *cbs = (XmToggleButtonCallbackStruct*) callData;

    //--- Comment out the following line when BulletinBoard::setShowPathLine is implemented:

    //    ::VkUnimplemented ( w, "BulletinBoard::setShowPathLine" );

    drawpathline = EZ(w);
    draw(w, callData);

    //---- End editable code block: BulletinBoard setShowPathLine

}    // End BulletinBoard::setShowPathLine()


void BulletinBoard::copy(   )
{
    // This member function is called when the user has selected
    // the Copy command from the Edit menu. You should copy the  
    // selected object in your program to on the clipboard. 



    //---- Start editable code block: BulletinBoard copy

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::copy" );




    //---- End editable code block: BulletinBoard copy

}    // End BulletinBoard::copy()


void BulletinBoard::cut(   )
{
    // This member function is called when the user has selected
    // the Cut command from the Edit menu. You should cut the  
    // selected object in your program and place it on the clipboard. 



    //---- Start editable code block: BulletinBoard cut

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::cut" );




    //---- End editable code block: BulletinBoard cut

}    // End BulletinBoard::cut()


void BulletinBoard::newFile(   )
{


    //---- Start editable code block: BulletinBoard newFile

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::newFile" );




    //---- End editable code block: BulletinBoard newFile

}    // End BulletinBoard::newFile()


void BulletinBoard::openFile( const char * filename )
{
    // This member function is called after the user has selected a new
    // file to be opened. The name of the file is given by the 
    // filename argument. You can get additional information by  
    // examining the state of theFileSelectionDialog object.



    //---- Start editable code block: BulletinBoard openFile

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::openFile" );




    //---- End editable code block: BulletinBoard openFile

}    // End BulletinBoard::openFile()


void BulletinBoard::paste(   )
{
    // This member function is called when the user has selected
    // the Paste command from the Edit menu. You should retrieve 
    // the contents of the clipbord  and insert it into your 
    // program as appropriate. 



    //---- Start editable code block: BulletinBoard paste

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::paste" );




    //---- End editable code block: BulletinBoard paste

}    // End BulletinBoard::paste()


void BulletinBoard::print( const char * filename )
{


    //---- Start editable code block: BulletinBoard print

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::print" );




    //---- End editable code block: BulletinBoard print

}    // End BulletinBoard::print()


void BulletinBoard::save(   )
{
    // This member function is called after the user has selected
    // a file to which to save. The name of the file is given by the 
    // filename argument. You can get additional information by 
    // examining the state of theFileSelectionDialog object.



    //---- Start editable code block: BulletinBoard save

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::save" );




    //---- End editable code block: BulletinBoard save

}    // End BulletinBoard::save()


void BulletinBoard::saveas( const char * filename )
{
    // This member function is called after the user has selected
    // a file to which to save. The name of the file is given by the 
    // filename argument. You can get additional information by 
    // examining the state of theFileSelectionDialog object.



    //---- Start editable code block: BulletinBoard saveas

    //--- Comment out this line when this function is implemented:

    ::VkUnimplemented ( NULL, "BulletinBoard::saveas" );




    //---- End editable code block: BulletinBoard saveas

}    // End BulletinBoard::saveas()





///////////////////////////////////////////////////////////////////
// static creation function, for importing class into rapidapp
// or dynamically loading, using VkComponent::loadComponent
///////////////////////////////////////////////////////////////////


VkComponent *BulletinBoard::CreateBulletinBoard( const char *name, Widget parent ) 
{  
    VkComponent *obj =  new BulletinBoard ( name, parent );
    return ( obj );
} // End CreateBulletinBoard


///////////////////////////////////////////////////////////////////
// Function for accessing a description of the dynamic interface
// to this class.
///////////////////////////////////////////////////////////////////


// WARNING: This structure is different than that used with 1.1 RapidApp.
// See the RapidApp release notes for details

struct InterfaceMap {
  char  *resourceName;
  char  *methodName;
  char  *argType;
  char  *definingClass; // Optional, if not this class
  void (VkCallbackObject::*method)(...); // Reserved, do not set
};


void *BulletinBoard::RegisterBulletinBoardInterface()
{ 
    // This structure registers information about this class
    // that allows RapidApp to create and manipulate an instance.
    // Each entry provides a resource name that will appear in the
    // resource manager palette when an instance of this class is
    // selected, the name of the member function as a string,
    // the type of the single argument to this function, and an.
    // optional argument indicating the class that defines this function.
    // All member functions must have the form
    //  
    //     void memberFunction ( Type );
    //
    // where "Type" is one of:
    //    const char *    (Use XmRString)
    //    Boolean         (Use XmRBoolean)
    //    int             (Use XmRInt)
    //    float           (Use XmRFloat)
    //    No argument     (Use VkRNoArg or "NoArg"
    //    A filename      (Use VkRFilename or "Filename")
    //    An enumeration  (Use "Enumeration:ClassName:Type: VALUE1, VALUE2, VALUE3")
    //    A callback      (Use XmRCallback)


    static InterfaceMap map[] = {
    //---- Start editable code block: BulletinBoardUI resource table

      // { "resourceName", "setAttribute", XmRString},
    //---- End editable code block: BulletinBoardUI resource table
      { NULL }, // MUST be NULL terminated
    };

    return map;
} // End RegisterBulletinBoardInterface()






//---- End of generated code

//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code


