
//////////////////////////////////////////////////////////////
//
// Header file for BulletinBoard
//
//    This file is generated by RapidApp 1.2
//
//    This class is derived from BulletinBoardUI which 
//    implements the user interface created in 
//    RapidApp. This class contains virtual
//    functions that are called from the user interface.
//
//    When you modify this header file, limit your changes to those
//    areas between the "//---- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//////////////////////////////////////////////////////////////
#ifndef BULLETINBOARD_H
#define BULLETINBOARD_H
#include "BulletinBoardUI.h"
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations


//---- BulletinBoard class declaration

class BulletinBoard : public BulletinBoardUI
{

  public:

    BulletinBoard ( const char *, Widget );
    BulletinBoard ( const char * );
    ~BulletinBoard();
    const char *  className();
    virtual void copy();
    virtual void cut();
    virtual void newFile();
    virtual void openFile(const char *);
    virtual void paste();
    virtual void print(const char *);
    virtual void save();
    virtual void saveas(const char *);

    static VkComponent *CreateBulletinBoard( const char *name, Widget parent ); 

    //---- Start editable code block: BulletinBoard public


    //---- End editable code block: BulletinBoard public



  protected:


    // These functions will be called as a result of callbacks
    // registered in BulletinBoardUI

    virtual void doAddToObstacle ( Widget, XtPointer );
    virtual void doAnimatePath ( Widget, XtPointer );
    virtual void doClearObstacles ( Widget, XtPointer );
    virtual void doClearRobot ( Widget, XtPointer );
    virtual void doComputePath ( Widget, XtPointer );
    virtual void doSetAsRobot ( Widget, XtPointer );
    virtual void doSetFinalPos ( Widget, XtPointer );
    virtual void doSetInitialPos ( Widget, XtPointer );
    virtual void doWriteAnimation ( Widget, XtPointer );
    virtual void doWriteOneFile ( Widget, XtPointer );
    virtual void doXNone ( Widget, XtPointer );
    virtual void doXOn ( Widget, XtPointer );
    virtual void doXReverse ( Widget, XtPointer );
    virtual void doYNone ( Widget, XtPointer );
    virtual void doYOn ( Widget, XtPointer );
    virtual void doYReverse ( Widget, XtPointer );
    virtual void draw ( Widget, XtPointer );
    virtual void init ( Widget, XtPointer );
    virtual void interact ( Widget, XtPointer );
    virtual void onFinalAngle ( Widget, XtPointer );
    virtual void onInitialAngle ( Widget, XtPointer );
    virtual void onRandomRoadMapSelect ( Widget, XtPointer );
    virtual void onRandomTreeSelect ( Widget, XtPointer );
    virtual void onSetEpslion ( Widget, XtPointer );
    virtual void onSetExtraSlider ( Widget, XtPointer );
    virtual void setShowAllSegments ( Widget, XtPointer );
    virtual void setShowPathLine ( Widget, XtPointer );

    //---- Start editable code block: BulletinBoard protected


    //---- End editable code block: BulletinBoard protected



  private:

    static void* RegisterBulletinBoardInterface();

    //---- Start editable code block: BulletinBoard private


    //---- End editable code block: BulletinBoard private


};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif

