
/////////////////////////////////////////////////////////////
//
// Source file for BulletinBoardUI
//
//    This class implements the user interface created in 
//    RapidApp.
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//
/////////////////////////////////////////////////////////////


#include "BulletinBoardUI.h" // Generated header file for this class

#include <GL/GLwMDrawA.h> 
#include <Sgm/Dial.h> 
#include <Xm/BulletinB.h> 
#include <Xm/Frame.h> 
#include <Xm/Label.h> 
#include <Xm/PushB.h> 
#include <Xm/Scale.h> 
#include <Xm/Separator.h> 
#include <Xm/ToggleB.h> 
#include <Vk/VkResource.h>
#include <Vk/VkOptionMenu.h>
#include <Vk/VkMenuItem.h>
//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  BulletinBoardUI::_defaultBulletinBoardUIResources[] = {
        "*addToObstacle.labelString:  Add To Obstacle",
        "*animatePath.labelString:  Animate Path",
        "*clearObstacles.labelString:  Clear Obstacles",
        "*clearRobot.labelString:  Clear Robot",
        "*computePath.labelString:  Compute Path",
        "*epsilon.titleString:  Epslion",
        "*extraSlider.titleString:  Extra Slider",
        "*planningMethod.labelString:  Planning Method",
        "*randomRoadmap.labelString:  Road Map",
        "*randomTree.labelString:  Rapid Tree",
        "*setAsRobot.labelString:  Set As Robot",
        "*setFinalAngle.labelString:  Set Final Angle",
        "*setFinalPos.labelString:  Set Final Pos",
        "*setInitialAngle.labelString:  Set Initial Angle",
        "*setInitialPos.labelString:  Set Initial Pos",
        "*showAllSegments.labelString:  Show All Paths",
        "*showPathLine.labelString:  Show Path Line",
        "*writeAnimation.labelString:  Write Animation",
        "*writeOneFile.labelString:  Write One File",
        "*xAxisIdentification.labelString:  X Axis Identification",
        "*xOn.labelString:  X On",
        "*xReverse.labelString:  X Reverse",
        "*xnone.labelString:  None",
        "*yAxisIdentification.labelString:  Y Axis Identification",
        "*yNone.labelString:  None",
        "*yOn.labelString:  Y On",
        "*yReverse.labelString:  Y Reverse",

        //---- Start editable code block: BulletinBoardUI Default Resources


        //---- End editable code block: BulletinBoardUI Default Resources

        (char*)NULL
};

BulletinBoardUI::BulletinBoardUI ( const char *name ) : VkComponent ( name ) 
{ 
    // No widgets are created by this constructor.
    // If an application creates a component using this constructor,
    // It must explictly call create at a later time.
    // This is mostly useful when adding pre-widget creation
    // code to a derived class constructor.

    //---- Start editable code block: BulletinBoard constructor 2


    //---- End editable code block: BulletinBoard constructor 2


}    // End Constructor




BulletinBoardUI::BulletinBoardUI ( const char *name, Widget parent ) : VkComponent ( name ) 
{ 
    //---- Start editable code block: BulletinBoard pre-create


    //---- End editable code block: BulletinBoard pre-create



    // Call creation function to build the widget tree.

     create ( parent );

    //---- Start editable code block: BulletinBoard constructor


    //---- End editable code block: BulletinBoard constructor


}    // End Constructor


BulletinBoardUI::~BulletinBoardUI() 
{
    // Base class destroys widgets

    //---- Start editable code block: BulletinBoardUI destructor


    //---- End editable code block: BulletinBoardUI destructor
}    // End destructor



void BulletinBoardUI::create ( Widget parent )
{
    Arg      args[11];
    Cardinal count;
    count = 0;

    // Load any class-defaulted resources for this object

    setDefaultResources ( parent, _defaultBulletinBoardUIResources  );


    // Create an unmanaged widget as the top of the widget hierarchy

    _baseWidget = _bulletinBoard = XtVaCreateWidget ( _name,
                                                      xmBulletinBoardWidgetClass,
                                                      parent, 
                                                      XmNresizePolicy, XmRESIZE_GROW, 
                                                      (XtPointer) NULL ); 

    // install a callback to guard against unexpected widget destruction

    installDestroyHandler();


    // Create widgets used in this component
    // All variables are data members of this class

    _writeAnimation = XtVaCreateManagedWidget  ( "writeAnimation",
                                                  xmPushButtonWidgetClass,
                                                  _baseWidget, 
                                                  XmNlabelType, XmSTRING, 
                                                  XmNx, 960, 
                                                  XmNy, 790, 
                                                  XmNwidth, 110, 
                                                  XmNheight, 32, 
                                                  (XtPointer) NULL ); 

    XtAddCallback ( _writeAnimation,
                    XmNactivateCallback,
                    &BulletinBoardUI::doWriteAnimationCallback,
                    (XtPointer) this ); 


    _writeOneFile = XtVaCreateManagedWidget  ( "writeOneFile",
                                                xmPushButtonWidgetClass,
                                                _baseWidget, 
                                                XmNlabelType, XmSTRING, 
                                                XmNx, 840, 
                                                XmNy, 790, 
                                                XmNwidth, 110, 
                                                XmNheight, 30, 
                                                (XtPointer) NULL ); 

    XtAddCallback ( _writeOneFile,
                    XmNactivateCallback,
                    &BulletinBoardUI::doWriteOneFileCallback,
                    (XtPointer) this ); 


    _extraSlider = XtVaCreateManagedWidget  ( "extraSlider",
                                               xmScaleWidgetClass,
                                               _baseWidget, 
					      XmNmaximum, 1000,
					      XmNorientation, XmHORIZONTAL, 
                                               XmNshowValue, True, 
                                               XmNx, 840, 
                                               XmNy, 720, 
                                               XmNwidth, 220, 
                                               XmNheight, 66, 
                                               (XtPointer) NULL ); 

    XtAddCallback ( _extraSlider,
                    XmNvalueChangedCallback,
                    &BulletinBoardUI::onSetExtraSliderCallback,
                    (XtPointer) this ); 

    XtAddCallback ( _extraSlider,
                    XmNdragCallback,
                    &BulletinBoardUI::onSetExtraSliderCallback,
                    (XtPointer) this ); 


    _epsilon = XtVaCreateManagedWidget  ( "epsilon",
                                           xmScaleWidgetClass,
                                           _baseWidget, 
					  XmNmaximum, 10,
                                           XmNorientation, XmHORIZONTAL, 
                                           XmNshowValue, True, 
                                           XmNx, 840, 
                                           XmNy, 660, 
                                           XmNwidth, 220, 
                                           XmNheight, 66, 
                                           (XtPointer) NULL ); 

    XtAddCallback ( _epsilon,
                    XmNdragCallback,
                    &BulletinBoardUI::onSetEpslionCallback,
                    (XtPointer) this ); 


    _setFinalAngle = XtVaCreateManagedWidget  ( "setFinalAngle",
                                                 xmLabelWidgetClass,
                                                 _baseWidget, 
                                                 XmNlabelType, XmSTRING, 
                                                 XmNx, 960, 
                                                 XmNy, 440, 
                                                 XmNwidth, 109, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 


    _setInitialAngle = XtVaCreateManagedWidget  ( "setInitialAngle",
                                                   xmLabelWidgetClass,
                                                   _baseWidget, 
                                                   XmNlabelType, XmSTRING, 
                                                   XmNx, 830, 
                                                   XmNy, 440, 
                                                   XmNwidth, 113, 
                                                   XmNheight, 30, 
                                                   (XtPointer) NULL ); 


    _separator3 = XtVaCreateManagedWidget  ( "separator3",
                                              xmSeparatorWidgetClass,
                                              _baseWidget, 
                                              XmNx, 850, 
                                              XmNy, 310, 
                                              XmNwidth, 200, 
                                              XmNheight, 20, 
                                              (XtPointer) NULL ); 


    _separator2 = XtVaCreateManagedWidget  ( "separator2",
                                              xmSeparatorWidgetClass,
                                              _baseWidget, 
                                              XmNx, 850, 
                                              XmNy, 530, 
                                              XmNwidth, 200, 
                                              XmNheight, 20, 
                                              (XtPointer) NULL ); 


    _addToObstacle = XtVaCreateManagedWidget  ( "addToObstacle",
                                                 xmPushButtonWidgetClass,
                                                 _baseWidget, 
                                                 XmNlabelType, XmSTRING, 
                                                 XmNx, 840, 
                                                 XmNy, 600, 
                                                 XmNwidth, 120, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 

    XtAddCallback ( _addToObstacle,
                    XmNactivateCallback,
                    &BulletinBoardUI::doAddToObstacleCallback,
                    (XtPointer) this ); 


    _computePath = XtVaCreateManagedWidget  ( "computePath",
                                               xmPushButtonWidgetClass,
                                               _baseWidget, 
                                               XmNlabelType, XmSTRING, 
                                               XmNx, 840, 
                                               XmNy, 270, 
                                               XmNwidth, 109, 
                                               XmNheight, 30, 
                                               (XtPointer) NULL ); 

    XtAddCallback ( _computePath,
                    XmNactivateCallback,
                    &BulletinBoardUI::doComputePathCallback,
                    (XtPointer) this ); 


    _finalAngle = XtVaCreateManagedWidget  ( "finalAngle",
                                              sgDialWidgetClass,
                                              _baseWidget, 
                                              XmNx, 970, 
                                              XmNy, 350, 
                                              XmNwidth, 80, 
                                              XmNheight, 80, 
                                              (XtPointer) NULL ); 

    XtAddCallback ( _finalAngle,
                    XmNdragCallback,
                    &BulletinBoardUI::onFinalAngleCallback,
                    (XtPointer) this ); 

    XtAddCallback ( _finalAngle,
                    XmNvalueChangedCallback,
                    &BulletinBoardUI::onFinalAngleCallback,
                    (XtPointer) this ); 


    _initialAngle = XtVaCreateManagedWidget  ( "initialAngle",
                                                sgDialWidgetClass,
                                                _baseWidget, 
                                                XmNx, 850, 
                                                XmNy, 350, 
                                                XmNwidth, 80, 
                                                XmNheight, 80, 
                                                (XtPointer) NULL ); 

    XtAddCallback ( _initialAngle,
                    XmNdragCallback,
                    &BulletinBoardUI::onInitialAngleCallback,
                    (XtPointer) this ); 

    XtAddCallback ( _initialAngle,
                    XmNvalueChangedCallback,
                    &BulletinBoardUI::onInitialAngleCallback,
                    (XtPointer) this ); 


    _setInitialPos = XtVaCreateManagedWidget  ( "setInitialPos",
                                                 xmPushButtonWidgetClass,
                                                 _baseWidget, 
                                                 XmNlabelType, XmSTRING, 
                                                 XmNx, 830, 
                                                 XmNy, 480, 
                                                 XmNwidth, 106, 
                                                 XmNheight, 30, 
                                                 (XtPointer) NULL ); 

    XtAddCallback ( _setInitialPos,
                    XmNactivateCallback,
                    &BulletinBoardUI::doSetInitialPosCallback,
                    (XtPointer) this ); 


    _setFinalPos = XtVaCreateManagedWidget  ( "setFinalPos",
                                               xmPushButtonWidgetClass,
                                               _baseWidget, 
                                               XmNlabelType, XmSTRING, 
                                               XmNx, 960, 
                                               XmNy, 480, 
                                               XmNwidth, 103, 
                                               XmNheight, 30, 
                                               (XtPointer) NULL ); 

    XtAddCallback ( _setFinalPos,
                    XmNactivateCallback,
                    &BulletinBoardUI::doSetFinalPosCallback,
                    (XtPointer) this ); 


    _setAsRobot = XtVaCreateManagedWidget  ( "setAsRobot",
                                              xmPushButtonWidgetClass,
                                              _baseWidget, 
                                              XmNlabelType, XmSTRING, 
                                              XmNx, 970, 
                                              XmNy, 600, 
                                              XmNwidth, 102, 
                                              XmNheight, 30, 
                                              (XtPointer) NULL ); 

    XtAddCallback ( _setAsRobot,
                    XmNactivateCallback,
                    &BulletinBoardUI::doSetAsRobotCallback,
                    (XtPointer) this ); 


    _clearRobot = XtVaCreateManagedWidget  ( "clearRobot",
                                              xmPushButtonWidgetClass,
                                              _baseWidget, 
                                              XmNlabelType, XmSTRING, 
                                              XmNx, 970, 
                                              XmNy, 560, 
                                              XmNwidth, 95, 
                                              XmNheight, 30, 
                                              (XtPointer) NULL ); 

    XtAddCallback ( _clearRobot,
                    XmNactivateCallback,
                    &BulletinBoardUI::doClearRobotCallback,
                    (XtPointer) this ); 


    _clearObstacles = XtVaCreateManagedWidget  ( "clearObstacles",
                                                  xmPushButtonWidgetClass,
                                                  _baseWidget, 
                                                  XmNlabelType, XmSTRING, 
                                                  XmNx, 840, 
                                                  XmNy, 560, 
                                                  XmNwidth, 120, 
                                                  XmNheight, 30, 
                                                  (XtPointer) NULL ); 

    XtAddCallback ( _clearObstacles,
                    XmNactivateCallback,
                    &BulletinBoardUI::doClearObstaclesCallback,
                    (XtPointer) this ); 


    _planningMethod = new VkOptionMenu ( _baseWidget, "planningMethod");
    _randomRoadmap =  _planningMethod->addAction ( "randomRoadmap", 
                                                   &BulletinBoardUI::onRandomRoadMapSelectCallback, 
                                                   (XtPointer) this );

    _randomTree =  _planningMethod->addAction ( "randomTree", 
                                                &BulletinBoardUI::onRandomTreeSelectCallback, 
                                                (XtPointer) this );

    _animatePath = XtVaCreateManagedWidget  ( "animatePath",
                                               xmPushButtonWidgetClass,
                                               _baseWidget, 
                                               XmNlabelType, XmSTRING, 
                                               XmNx, 960, 
                                               XmNy, 270, 
                                               XmNwidth, 104, 
                                               XmNheight, 30, 
                                               (XtPointer) NULL ); 

    XtAddCallback ( _animatePath,
                    XmNactivateCallback,
                    &BulletinBoardUI::doAnimatePathCallback,
                    (XtPointer) this ); 


    _showPathLine = XtVaCreateManagedWidget  ( "showPathLine",
                                                xmToggleButtonWidgetClass,
                                                _baseWidget, 
                                                XmNalignment, XmALIGNMENT_BEGINNING, 
                                                XmNlabelType, XmSTRING, 
                                                XmNindicatorSize, 10, 
                                                XmNindicatorType, Xm3D_N_OF_MANY, 
                                                XmNx, 890, 
                                                XmNy, 230, 
                                                XmNwidth, 123, 
                                                XmNheight, 26, 
                                                (XtPointer) NULL ); 

    XtAddCallback ( _showPathLine,
                    XmNvalueChangedCallback,
                    &BulletinBoardUI::setShowPathLineCallback,
                    (XtPointer) this ); 


    _showAllSegments = XtVaCreateManagedWidget  ( "showAllSegments",
                                                   xmToggleButtonWidgetClass,
                                                   _baseWidget, 
                                                   XmNalignment, XmALIGNMENT_BEGINNING, 
                                                   XmNlabelType, XmSTRING, 
                                                   XmNindicatorSize, 10, 
                                                   XmNindicatorType, Xm3D_N_OF_MANY, 
                                                   XmNx, 890, 
                                                   XmNy, 190, 
                                                   XmNwidth, 118, 
                                                   XmNheight, 30, 
                                                   (XtPointer) NULL ); 

    XtAddCallback ( _showAllSegments,
                    XmNvalueChangedCallback,
                    &BulletinBoardUI::setShowAllSegmentsCallback,
                    (XtPointer) this ); 


    _yAxisIdentification = new VkOptionMenu ( _baseWidget, "yAxisIdentification");
    _yNone =  _yAxisIdentification->addAction ( "yNone", 
                                                &BulletinBoardUI::doYNoneCallback, 
                                                (XtPointer) this );

    _yOn =  _yAxisIdentification->addAction ( "yOn", 
                                              &BulletinBoardUI::doYOnCallback, 
                                              (XtPointer) this );


    _yReverse =  _yAxisIdentification->addAction ( "yReverse", 
                                                   &BulletinBoardUI::doYReverseCallback, 
                                                   (XtPointer) this );

    _xAxisIdentification = new VkOptionMenu ( _baseWidget, "xAxisIdentification");
    _xnone =  _xAxisIdentification->addAction ( "xnone", 
                                                &BulletinBoardUI::doXNoneCallback, 
                                                (XtPointer) this );

    _xOn =  _xAxisIdentification->addAction ( "xOn", 
                                              &BulletinBoardUI::doXOnCallback, 
                                              (XtPointer) this );

    _xReverse =  _xAxisIdentification->addAction ( "xReverse", 
                                                   &BulletinBoardUI::doXReverseCallback, 
                                                   (XtPointer) this );

    _frame = XtVaCreateManagedWidget  ( "frame",
                                         xmFrameWidgetClass,
                                         _baseWidget, 
                                         XmNshadowType, XmSHADOW_ETCHED_IN, 
                                         XmNx, 20, 
                                         XmNy, 10, 
                                         XmNwidth, 800, 
                                         XmNheight, 800, 
                                         (XtPointer) NULL ); 


    _display = XtVaCreateManagedWidget  ( "display",
                                           glwMDrawingAreaWidgetClass,
                                           _frame, 
                                           GLwNrgba, True, 
                                           GLwNdoublebuffer, True, 
                                           GLwNallocateBackground, True, 
                                           XmNwidth, 794, 
                                           XmNheight, 794, 
                                           (XtPointer) NULL ); 

    XtAddCallback ( _display,
                    GLwNginitCallback,
                    &BulletinBoardUI::initCallback,
                    (XtPointer) this ); 

    XtAddCallback ( _display,
                    GLwNinputCallback,
                    &BulletinBoardUI::interactCallback,
                    (XtPointer) this ); 

    XtAddCallback ( _display,
                    GLwNexposeCallback,
                    &BulletinBoardUI::drawCallback,
                    (XtPointer) this ); 


    XtVaSetValues ( _planningMethod->baseWidget(),
                    XmNx, 830, 
                    XmNy, 30, 
                    XmNwidth, 241, 
                    XmNheight, 32, 
                    (XtPointer) NULL );
    XtVaSetValues ( _yAxisIdentification->baseWidget(),
                    XmNx, 830, 
                    XmNy, 130, 
                    XmNwidth, 234, 
                    XmNheight, 32, 
                    (XtPointer) NULL );
    XtVaSetValues ( _xAxisIdentification->baseWidget(),
                    XmNx, 830, 
                    XmNy, 80, 
                    XmNwidth, 233, 
                    XmNheight, 32, 
                    (XtPointer) NULL );

    //---- Start editable code block: BulletinBoardUI create


    //---- End editable code block: BulletinBoardUI create
}

const char * BulletinBoardUI::className()
{
    return ("BulletinBoardUI");
}    // End className()




/////////////////////////////////////////////////////////////// 
// The following functions are static member functions used to 
// interface with Motif.
/////////////////////////////////// 

void BulletinBoardUI::doAddToObstacleCallback ( Widget    w,
                                                XtPointer clientData,
                                                XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doAddToObstacle ( w, callData );
}

void BulletinBoardUI::doAnimatePathCallback ( Widget    w,
                                              XtPointer clientData,
                                              XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doAnimatePath ( w, callData );
}

void BulletinBoardUI::doClearObstaclesCallback ( Widget    w,
                                                 XtPointer clientData,
                                                 XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doClearObstacles ( w, callData );
}

void BulletinBoardUI::doClearRobotCallback ( Widget    w,
                                             XtPointer clientData,
                                             XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doClearRobot ( w, callData );
}

void BulletinBoardUI::doComputePathCallback ( Widget    w,
                                              XtPointer clientData,
                                              XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doComputePath ( w, callData );
}

void BulletinBoardUI::doSetAsRobotCallback ( Widget    w,
                                             XtPointer clientData,
                                             XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doSetAsRobot ( w, callData );
}

void BulletinBoardUI::doSetFinalPosCallback ( Widget    w,
                                              XtPointer clientData,
                                              XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doSetFinalPos ( w, callData );
}

void BulletinBoardUI::doSetInitialPosCallback ( Widget    w,
                                                XtPointer clientData,
                                                XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doSetInitialPos ( w, callData );
}

void BulletinBoardUI::doWriteAnimationCallback ( Widget    w,
                                                 XtPointer clientData,
                                                 XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doWriteAnimation ( w, callData );
}

void BulletinBoardUI::doWriteOneFileCallback ( Widget    w,
                                               XtPointer clientData,
                                               XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doWriteOneFile ( w, callData );
}

void BulletinBoardUI::doXNoneCallback ( Widget    w,
                                        XtPointer clientData,
                                        XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doXNone ( w, callData );
}

void BulletinBoardUI::doXOnCallback ( Widget    w,
                                      XtPointer clientData,
                                      XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doXOn ( w, callData );
}

void BulletinBoardUI::doXReverseCallback ( Widget    w,
                                           XtPointer clientData,
                                           XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doXReverse ( w, callData );
}

void BulletinBoardUI::doYNoneCallback ( Widget    w,
                                        XtPointer clientData,
                                        XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doYNone ( w, callData );
}

void BulletinBoardUI::doYOnCallback ( Widget    w,
                                      XtPointer clientData,
                                      XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doYOn ( w, callData );
}

void BulletinBoardUI::doYReverseCallback ( Widget    w,
                                           XtPointer clientData,
                                           XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->doYReverse ( w, callData );
}

void BulletinBoardUI::drawCallback ( Widget    w,
                                     XtPointer clientData,
                                     XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->draw ( w, callData );
}

void BulletinBoardUI::initCallback ( Widget    w,
                                     XtPointer clientData,
                                     XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->init ( w, callData );
}

void BulletinBoardUI::interactCallback ( Widget    w,
                                         XtPointer clientData,
                                         XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->interact ( w, callData );
}

void BulletinBoardUI::onFinalAngleCallback ( Widget    w,
                                             XtPointer clientData,
                                             XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onFinalAngle ( w, callData );
}

void BulletinBoardUI::onInitialAngleCallback ( Widget    w,
                                               XtPointer clientData,
                                               XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onInitialAngle ( w, callData );
}

void BulletinBoardUI::onRandomRoadMapSelectCallback ( Widget    w,
                                                      XtPointer clientData,
                                                      XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onRandomRoadMapSelect ( w, callData );
}

void BulletinBoardUI::onRandomTreeSelectCallback ( Widget    w,
                                                   XtPointer clientData,
                                                   XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onRandomTreeSelect ( w, callData );
}

void BulletinBoardUI::onSetEpslionCallback ( Widget    w,
                                             XtPointer clientData,
                                             XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onSetEpslion ( w, callData );
}

void BulletinBoardUI::onSetExtraSliderCallback ( Widget    w,
                                                 XtPointer clientData,
                                                 XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->onSetExtraSlider ( w, callData );
}

void BulletinBoardUI::setShowAllSegmentsCallback ( Widget    w,
                                                   XtPointer clientData,
                                                   XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->setShowAllSegments ( w, callData );
}

void BulletinBoardUI::setShowPathLineCallback ( Widget    w,
                                                XtPointer clientData,
                                                XtPointer callData ) 
{ 
    BulletinBoardUI* obj = ( BulletinBoardUI * ) clientData;
    obj->setShowPathLine ( w, callData );
}



/////////////////////////////////////////////////////////////// 
// The following functions are called from the menu items 
// in this window.
/////////////////////////////////// 

void BulletinBoardUI::doAddToObstacle ( Widget, XtPointer ) 
{
    // This virtual function is called from doAddToObstacleCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doAnimatePath ( Widget, XtPointer ) 
{
    // This virtual function is called from doAnimatePathCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doClearObstacles ( Widget, XtPointer ) 
{
    // This virtual function is called from doClearObstaclesCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doClearRobot ( Widget, XtPointer ) 
{
    // This virtual function is called from doClearRobotCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doComputePath ( Widget, XtPointer ) 
{
    // This virtual function is called from doComputePathCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doSetAsRobot ( Widget, XtPointer ) 
{
    // This virtual function is called from doSetAsRobotCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doSetFinalPos ( Widget, XtPointer ) 
{
    // This virtual function is called from doSetFinalPosCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doSetInitialPos ( Widget, XtPointer ) 
{
    // This virtual function is called from doSetInitialPosCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doWriteAnimation ( Widget, XtPointer ) 
{
    // This virtual function is called from doWriteAnimationCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doWriteOneFile ( Widget, XtPointer ) 
{
    // This virtual function is called from doWriteOneFileCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doXNone ( Widget, XtPointer ) 
{
    // This virtual function is called from doXNoneCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doXOn ( Widget, XtPointer ) 
{
    // This virtual function is called from doXOnCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doXReverse ( Widget, XtPointer ) 
{
    // This virtual function is called from doXReverseCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doYNone ( Widget, XtPointer ) 
{
    // This virtual function is called from doYNoneCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doYOn ( Widget, XtPointer ) 
{
    // This virtual function is called from doYOnCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::doYReverse ( Widget, XtPointer ) 
{
    // This virtual function is called from doYReverseCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::draw ( Widget, XtPointer ) 
{
    // This virtual function is called from drawCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::init ( Widget, XtPointer ) 
{
    // This virtual function is called from initCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::interact ( Widget, XtPointer ) 
{
    // This virtual function is called from interactCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onFinalAngle ( Widget, XtPointer ) 
{
    // This virtual function is called from onFinalAngleCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onInitialAngle ( Widget, XtPointer ) 
{
    // This virtual function is called from onInitialAngleCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onRandomRoadMapSelect ( Widget, XtPointer ) 
{
    // This virtual function is called from onRandomRoadMapSelectCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onRandomTreeSelect ( Widget, XtPointer ) 
{
    // This virtual function is called from onRandomTreeSelectCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onSetEpslion ( Widget, XtPointer ) 
{
    // This virtual function is called from onSetEpslionCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::onSetExtraSlider ( Widget, XtPointer ) 
{
    // This virtual function is called from onSetExtraSliderCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::setShowAllSegments ( Widget, XtPointer ) 
{
    // This virtual function is called from setShowAllSegmentsCallback.
    // This function is normally overriden by a derived class.

}

void BulletinBoardUI::setShowPathLine ( Widget, XtPointer ) 
{
    // This virtual function is called from setShowPathLineCallback.
    // This function is normally overriden by a derived class.

}



//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code
