
//////////////////////////////////////////////////////////////
//
// Header file for BulletinBoardUI
//
//    This file is generated by RapidApp 1.2
//
//    This class implements the user interface portion of a class
//    Normally it is not used directly.
//    Instead the subclass, BulletinBoard is instantiated
//
//    To extend or alter the behavior of this class, you should
//    modify the BulletinBoard files
//
//    Restrict changes to those sections between
//    the "//--- Start/End editable code block" markers
//
//    This will allow RapidApp to integrate changes more easily
//
//    This class is a ViewKit user interface "component".
//    For more information on how components are used, see the
//    "ViewKit Programmers' Manual", and the RapidApp
//    User's Guide.
//
//////////////////////////////////////////////////////////////
#ifndef BULLETINBOARDUI_H
#define BULLETINBOARDUI_H
#include <Vk/VkComponent.h>


//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations


class VkOptionMenu;
class VkMenuAction;
class VkMenuToggle;
class VkMenuItem;
class BulletinBoardUI : public VkComponent
{ 

  public:

    BulletinBoardUI ( const char *, Widget );
    BulletinBoardUI ( const char * );
    ~BulletinBoardUI();
    void create ( Widget );
    const char *  className();

    //---- Start editable code block: BulletinBoard public


    //---- End editable code block: BulletinBoard public


  protected:


    // Widgets created by this class

    Widget  _addToObstacle;
    Widget  _animatePath;
    Widget  _bulletinBoard;
    Widget  _clearObstacles;
    Widget  _clearRobot;
    Widget  _computePath;
    Widget  _display;
    Widget  _epsilon;
    Widget  _extraSlider;
    Widget  _finalAngle;
    Widget  _frame;
    Widget  _initialAngle;
    Widget  _separator2;
    Widget  _separator3;
    Widget  _setAsRobot;
    Widget  _setFinalAngle;
    Widget  _setFinalPos;
    Widget  _setInitialAngle;
    Widget  _setInitialPos;
    Widget  _showAllSegments;
    Widget  _showPathLine;
    Widget  _writeAnimation;
    Widget  _writeOneFile;

    VkOptionMenu  *_planningMethod;
    VkOptionMenu  *_xAxisIdentification;
    VkOptionMenu  *_yAxisIdentification;

    VkMenuItem *_randomRoadmap;
    VkMenuItem *_randomTree;
    VkMenuItem *_xOn;
    VkMenuItem *_xReverse;
    VkMenuItem *_xnone;
    VkMenuItem *_yNone;
    VkMenuItem *_yOn;
    VkMenuItem *_yReverse;


    // These virtual functions are called from the private callbacks (below)
    // Intended to be overriden in derived classes to define actions

    virtual void doAddToObstacle ( Widget, XtPointer );
    virtual void doAnimatePath ( Widget, XtPointer );
    virtual void doClearObstacles ( Widget, XtPointer );
    virtual void doClearRobot ( Widget, XtPointer );
    virtual void doComputePath ( Widget, XtPointer );
    virtual void doSetAsRobot ( Widget, XtPointer );
    virtual void doSetFinalPos ( Widget, XtPointer );
    virtual void doSetInitialPos ( Widget, XtPointer );
    virtual void doWriteAnimation ( Widget, XtPointer );
    virtual void doWriteOneFile ( Widget, XtPointer );
    virtual void doXNone ( Widget, XtPointer );
    virtual void doXOn ( Widget, XtPointer );
    virtual void doXReverse ( Widget, XtPointer );
    virtual void doYNone ( Widget, XtPointer );
    virtual void doYOn ( Widget, XtPointer );
    virtual void doYReverse ( Widget, XtPointer );
    virtual void draw ( Widget, XtPointer );
    virtual void init ( Widget, XtPointer );
    virtual void interact ( Widget, XtPointer );
    virtual void onFinalAngle ( Widget, XtPointer );
    virtual void onInitialAngle ( Widget, XtPointer );
    virtual void onRandomRoadMapSelect ( Widget, XtPointer );
    virtual void onRandomTreeSelect ( Widget, XtPointer );
    virtual void onSetEpslion ( Widget, XtPointer );
    virtual void onSetExtraSlider ( Widget, XtPointer );
    virtual void setShowAllSegments ( Widget, XtPointer );
    virtual void setShowPathLine ( Widget, XtPointer );

    //---- Start editable code block: BulletinBoard protected


    //---- End editable code block: BulletinBoard protected


  private: 

    // Array of default resources

    static String      _defaultBulletinBoardUIResources[];


    // Callbacks to interface with Motif

    static void doAddToObstacleCallback ( Widget, XtPointer, XtPointer );
    static void doAnimatePathCallback ( Widget, XtPointer, XtPointer );
    static void doClearObstaclesCallback ( Widget, XtPointer, XtPointer );
    static void doClearRobotCallback ( Widget, XtPointer, XtPointer );
    static void doComputePathCallback ( Widget, XtPointer, XtPointer );
    static void doSetAsRobotCallback ( Widget, XtPointer, XtPointer );
    static void doSetFinalPosCallback ( Widget, XtPointer, XtPointer );
    static void doSetInitialPosCallback ( Widget, XtPointer, XtPointer );
    static void doWriteAnimationCallback ( Widget, XtPointer, XtPointer );
    static void doWriteOneFileCallback ( Widget, XtPointer, XtPointer );
    static void doXNoneCallback ( Widget, XtPointer, XtPointer );
    static void doXOnCallback ( Widget, XtPointer, XtPointer );
    static void doXReverseCallback ( Widget, XtPointer, XtPointer );
    static void doYNoneCallback ( Widget, XtPointer, XtPointer );
    static void doYOnCallback ( Widget, XtPointer, XtPointer );
    static void doYReverseCallback ( Widget, XtPointer, XtPointer );
    static void drawCallback ( Widget, XtPointer, XtPointer );
    static void initCallback ( Widget, XtPointer, XtPointer );
    static void interactCallback ( Widget, XtPointer, XtPointer );
    static void onFinalAngleCallback ( Widget, XtPointer, XtPointer );
    static void onInitialAngleCallback ( Widget, XtPointer, XtPointer );
    static void onRandomRoadMapSelectCallback ( Widget, XtPointer, XtPointer );
    static void onRandomTreeSelectCallback ( Widget, XtPointer, XtPointer );
    static void onSetEpslionCallback ( Widget, XtPointer, XtPointer );
    static void onSetExtraSliderCallback ( Widget, XtPointer, XtPointer );
    static void setShowAllSegmentsCallback ( Widget, XtPointer, XtPointer );
    static void setShowPathLineCallback ( Widget, XtPointer, XtPointer );

    //---- Start editable code block: BulletinBoard private


    //---- End editable code block: BulletinBoard private
};
//---- Start editable code block: End of generated code


//---- End editable code block: End of generated code

#endif

